package solatium.gui;

import com.sun.tools.javac.comp.Todo;
import org.assertj.swing.edt.GuiActionRunner;
import org.assertj.swing.fixture.FrameFixture;
import org.assertj.swing.fixture.JButtonFixture;
import org.assertj.swing.fixture.JLabelFixture;
import org.assertj.swing.fixture.JTextComponentFixture;
import org.assertj.swing.junit.testcase.AssertJSwingJUnitTestCase;
import org.junit.Test;

import javax.swing.*;

import java.awt.event.KeyEvent;

import static org.junit.Assert.*;

public class LoginTest extends AssertJSwingJUnitTestCase {

    // Eine "Referenz" auf die SwingAnwendung.
    private FrameFixture window;

    @Override
    protected void onSetUp() {
        // Starten der SwingAnwendung
        Login frame = GuiActionRunner.execute(() -> new Login());
        window = new FrameFixture(robot(), frame);
        window.show();
    }

    @Override
    protected void onTearDown() {
        window.close();
    }

    @Test
    public void shouldLogIn() {
        // TODO: 2019-09-13 add user for testing

        JButtonFixture loginBtn = window.button("loginBtn");
        loginBtn.click();

        //assertFalse(window.isEnabled());
    }

    @Test
    public void shouldShowErrorMsg() {
        JTextComponentFixture idField = window.textBox("idField");
        JButtonFixture loginBtn = window.button("loginBtn");

        idField.pressAndReleaseKeys(KeyEvent.VK_U);

        loginBtn.click();

        JLabelFixture errorMsg = window.label("errorMsg");
        errorMsg.requireText("Wrong Password");
    }
}
